<?php
set_time_limit(0);

$exclude_files = array(
	$_SERVER['DOCUMENT_ROOT'] . '/' . 'scan_files.php',
);

$exclude_dirs = array(
	$_SERVER['DOCUMENT_ROOT'] . '/' . 'stats',
);

$update = $_REQUEST["u"] == "1";

function scan_files($dir) {

	global $exclude_files, $exclude_dirs, $update;

	// malware strings to search

	$dirs_array = array();

	if ($handle = opendir($dir)) {

		echo "Processing directory: " . $dir . "<br/>\n";

		// this is the correct way to loop over the directory.
		while (false !== ($file = readdir($handle))) {
			if ($file != '.' && $file != '..') {
				$path = $dir . $file;

				if (is_file($path)) {

					// exclude files
					if (in_array($path, $exclude_files)) {
						continue;
					}

					if (endsWith($path, '.html.bak') ||
						endsWith($path, '.htm.bak') ||
						endsWith($path, '.shtml.bak') ||
						endsWith($path, '.js.bak') ||
						endsWith($path, '.php.bak')) {
						echo "<font color='red'>===>" . $path . "</font><br/>\n";
						if ($update) {
							unlink($path);
						}
					}

				} elseif (is_dir($path)) {
					if (in_array($path, $exclude_dirs)) {
						continue;
					}
					$dirs_array[] = $path;
				}
			}
		}

		closedir($handle);
	}

	foreach ($dirs_array as $dir) {
		scan_files($dir . '/');
	}

	unset($dirs_array);
}

function endsWith($string, $ending) {
	$len = strlen($ending);
	$string_end = substr($string, strlen($string) - $len);

	return $string_end == $ending;
}

$start_dir = $_SERVER['DOCUMENT_ROOT'] . '/';

echo 'Starting from: ' . $start_dir . "<br/>\n";

scan_files($start_dir);

?>